﻿namespace Phoenix.Main.Frame.Configuration
{
    using System.Windows.Forms;

    using Phoenix.Main.Configuration;

    /// <summary>
    /// Provides a control to manage the shortcutsNode of Phoenix
    /// </summary>
    public class ShortcutConfigurationControl : PropertyGrid, IConfigurationControl
    {
        #region Fields

        private ShortcutConfiguration shortcuts = new ShortcutConfiguration();

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="ShortcutConfigurationControl"/> class.
        /// </summary>
        public ShortcutConfigurationControl()
        {
            base.SelectedObject = this.shortcuts;
        }

        #endregion Constructors

        #region Methods

        /// <summary>
        /// Rollback theconfiguration date to the previous state.
        /// </summary>
        public void Rollback()
        {
            this.shortcuts.Rollback();
        }

        /// <summary>
        /// Saves the configuration in the config file.
        /// </summary>
        public void SaveConfiguration()
        {
            this.shortcuts.CommitChanges();
        }

        #endregion Methods
    }
}