﻿namespace Phoenix.Model.Management
{
    using Phoenix.Model.Bll.Domain;
    using Phoenix.Model.Bll.Interface;
    using Phoenix.Model.Dal;

    /// <summary>
    /// Manager for debugging purpose
    /// </summary>
    public class DebugModel
    {
        #region Fields

        private IPatientRepository patientRepository = RepositoryFactory.Get<IPatientRepository>();

        #endregion Fields

        #region Properties

        /// <summary>
        /// Gets a patient for debuggin purpose or null if he does not exist.
        /// </summary>
        /// <value>The debug patient.</value>
        public Patient DebugPatient
        {
            get
            {
                return patientRepository.GetDebugPatient();
            }
        }

        #endregion Properties
    }
}