﻿namespace Phoenix.Model.Core.Management
{
    using System;

    using Phoenix.Model.Bll.Interface;
    using Phoenix.Model.Dal;
    using Phoenix.Presenter.Interfaces.Manager;

    /// <summary>
    /// Manages the pathologies of a patient
    /// </summary>
    public class PathologiesHistoryModel
    {
        #region Fields

        private IPathologiesHistoryPresenter presenter;
        private IPatientRepository repository = RepositoryFactory.Get<IPatientRepository>();

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="PathologiesHistoryModel"/> class.
        /// </summary>
        /// <param name="presenter">The presenter.</param>
        public PathologiesHistoryModel(IPathologiesHistoryPresenter presenter)
        {
            this.presenter = presenter;
            this.presenter.Updated += presenter_Updated;
        }

        #endregion Constructors

        #region Methods

        void presenter_Updated(object sender, EventArgs e)
        {
            this.repository.Update(this.presenter.Patient);
        }

        #endregion Methods
    }
}