﻿namespace Phoenix.Model.Core.Management
{
    using Phoenix.Model.Bll.Interface;
    using Phoenix.Model.Dal;
    using Phoenix.Presenter.Interfaces.Manager;

    /// <summary>
    /// Insert a new patient in a repository
    /// </summary>
    public class PatientInserterModel
    {
        #region Fields

        private IPatientInserterPresenter presenter;
        private IPatientRepository repository = RepositoryFactory.Get<IPatientRepository>();

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="PatientInserterModel"/> class.
        /// </summary>
        /// <param name="presenter">The presenter.</param>
        public PatientInserterModel(IPatientInserterPresenter presenter)
        {
            this.presenter = presenter;
            this.presenter.Inserted += (sender, e) => this.repository.Create(e.Data);
        }

        #endregion Constructors
    }
}