﻿namespace Phoenix.Model.Dal.Repositories
{
    using System;

    using Phoenix.Model.Bll.Domain;
    using Phoenix.Model.Bll.Interface;

    /// <summary>
    /// Implementation of a keyword group repository for SQLite
    /// </summary>
    public class KeywordGroupRepository : Repository<KeywordGroup>, IKeywordGroupRepository
    {
        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="KeywordGroupRepository"/> class.
        /// </summary>
        public KeywordGroupRepository()
            : base("KeywordGroup", "Title")
        {
        }

        #endregion Constructors

        #region Methods

        /// <summary>
        /// Determines whether the specified item is referenced.
        /// </summary>
        /// <param name="item">The item.</param>
        /// <returns>
        /// 	<c>true</c> if the specified item is referenced; otherwise, <c>false</c>.
        /// </returns>
        public override bool IsReferenced(KeywordGroup item)
        {
            return false;
        }

        /// <summary>
        /// Removes all items from repository.
        /// /!\ For testing purpose
        /// </summary>
        [Obsolete(@"/!\ For testing purpose /!\")]
        public void RemoveAll()
        {
            foreach (KeywordGroup each in this.GetAllRows())
            {
                this.Session.Delete(each);
            }
        }

        #endregion Methods
    }
}