﻿namespace Phoenix.Presenter.Interfaces
{
    using System;

    using Phoenix.Helpers.Misc;

    /// <summary>
    /// Use this interface for manager that deletes item from the repository.
    /// </summary>
    /// <typeparam name="T">The type of the item to delete</typeparam>
    // TODO: check if it can be refactored and removed
    public interface IDeleter<T>
    {
        #region Events

        /// <summary>
        /// Occurs when the user asked a deletion of an item.
        /// </summary>
        event EventHandler<EventArgs<T>> Deleted;

        #endregion Events

        #region Properties

        T ItemToDelete
        {
            get; set;
        }

        #endregion Properties
    }
}