﻿namespace Phoenix.Presenter.Sessions
{
    using System;

    using Phoenix.Presenter.Interfaces;

    /// <summary>
    /// Provides feature to close, save or discard open sessions.
    /// </summary>
    public class SessionDisposer
    {
        #region Fields

        ISessionDisposer view;

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of the <see cref="SessionDisposer"/> class.
        /// </summary>
        /// <param name="view">The presenter.</param>
        public SessionDisposer(ISessionDisposer view)
        {
            this.view = view;
            this.view.SessionsClosing += view_ClosingSessions;
        }

        #endregion Constructors

        #region Methods

        private void view_ClosingSessions(object sender, EventArgs e)
        {
            this.view.StartGuiWait();
            foreach (var session in this.view.SessionsToClose)
                session.Close();
            this.view.EndGuiWait();
        }

        #endregion Methods
    }
}