import sys;
import os;
import string;

class HeaderCreator:
	#private member
	__HeaderPath = "";
	__Header = "";
	__Extention = ".cs";
#=============================================================================#
	#Ctor
	def __init__(self, HeaderPath):
		self.__HeaderPath = HeaderPath;	
#=============================================================================#		
	#Methods
	def addHeader(self, sFrom):
		self.__loadHeader();
		self.__findAllFile(sFrom, self.__addHeader);
#=============================================================================#
	def removeHeader(self, sFrom):
		self.__loadHeader();
		self.__findAllFile(sFrom, self.__removeHeader);
#=============================================================================#
	def __loadHeader(self):		
		try:
			with open(self.__HeaderPath, 'r') as headerFile:
				self.__Header = headerFile.read();				
			headerFile.closed;
		except Exception as ex:
			print("Error occured loading the header: ", ex.args, "Path:", self.__HeaderPath); 		
#=============================================================================#	
	def __findAllFile(self, path, delegateMethod):
		count = 0;
		dirs = os.walk(path);		
		for dir in dirs:				
			for file in dir[2]:
				strFile = str(file);
				fullPath = dir[0] + "\\" + file;
				if(strFile.endswith(self.__Extention)):		
					count = count + 1;
					delegateMethod(fullPath, file);
		print(count, " file(s) found");
#=============================================================================#
	def __addHeader(self, fullPath, filename):
		fileContent = "";			
		#print("- Process'", filename + "'");
		try:
			with open(fullPath, 'r') as file:
				fileContent = file.read();						
				file.close();				
			if(fileContent.startswith(self.__Header) == False):
				with open(fullPath, 'w') as file:
					file.write(self.__Header + fileContent);
					file.close();								
		except Exception as ex:
			print("Error occured adding the header: ", ex.args, "Path", fullPath); 
#=============================================================================#
	def __removeHeader(self, fullPath, filename):
		fileContent = "";			
		#print("- Process '" + filename + "'");
		try:			
			with open(fullPath, 'r') as file:
				fileContent = file.read();						
				file.close();				
			if(fileContent.startswith(self.__Header) == True):
				with open(fullPath, 'w') as file:
					newFileContent = fileContent.replace(self.__Header, "")					
					file.write(newFileContent);
					file.close();								
		except Exception as ex:
			print("Error occured removing the header: ", ex.args, "Path", fullPath); 
#=============================================================================#
def main(args):
	if(len(args) != 4):
		cmd = "";
		print("Command arguments badly written. Write like this: CMD [add | remove] [Path_To_Header] [Path_To_Process]");
		exit();
	else:		
		pathToHeader = str(args[2]);
		path = str(args[3]);	
		
		creator = HeaderCreator(pathToHeader);		
		arg = str(args[1]);
		arg = arg.lower();	
		
		if(arg == 'add'):
			print("Add header...");
			creator.addHeader(path);
			print("Header added.");
			
		elif (arg == 'remove'):
				print("Remove header...");
				creator.removeHeader(path);
				print("Header removed.");
				
		else:
			print("The argument is '" + arg + "' which is neither 'add' nor 'remove'!");
			exit();			
	#input("Press any key to continue");
#=============================================================================#		
if __name__ == "__main__":
        main(sys.argv)
